"""
Proxy/Cache a remote XML document.
"""
# $Id: XMLProxy.py,v 1.5 2001/10/24 15:34:12 adrian Exp $
#
# $Log: XMLProxy.py,v $
# Revision 1.5  2001/10/24 15:34:12  adrian
# Completed factoring out common code into 3 base classes
# (XMLClientBase, XMLServerBase, and XMLReloadBase)
#
# Completed XMLProxy.
#
# Revision 1.4  2001/10/22 15:40:00  adrian
# Started moving common functions to base classes
#
# Revision 1.3  2001/10/22 11:55:36  adrian
# Added XMLProxy class. XMLProxy combines the download/cache
# ability of XMLDocument with the Method interface of XMLFile, to
# provide a simple way to cache remote XML source locally within Zope.
#
# Revision 1.2  2001/10/21 15:10:16  adrian
# no message
#
#
__version__ = '$Revision: 1.5 $'[11:-2]

import Globals
import AccessControl.Role
import OFS.SimpleItem
import OFS.PropertyManager
import Persistence
import Acquisition
import XML
import OFS.History
import DateTime
import urllib
from DocumentTemplate import DT_HTML
import XMLKitBase

manage_addXMLProxyForm = Globals.HTMLFile('www/addXMLProxy', globals())
def manage_addXMLProxy(self, id='', source='', submit=None, REQUEST=None):
    """ """
    obj = XMLProxy(str(id), str(source))
    self._setObject(obj.getId(), obj)
    if REQUEST is not None:
        try: u=self.DestinationURL()
        except: u=REQUEST['URL1']
        if submit==" Add and Edit ": u="%s/%s" % (u, urllib.quote(obj.getId()))
        REQUEST.RESPONSE.redirect(u+'/manage_workspace')
    return ''

class XMLProxy(
        OFS.PropertyManager.PropertyManager,
        OFS.SimpleItem.SimpleItem,
        Persistence.Persistent,
        Acquisition.Implicit,
        AccessControl.Role.RoleManager,
        OFS.History.Historical,
        XMLKitBase.XMLClientBase,
        XMLKitBase.XMLServerBase,
        XMLKitBase.XMLReloadBase,
    ):
    """ """
    id = "XMLProxy"
    title = "XML Proxy"
    meta_type = "XML Proxy"
    index_html = None

    # Masquerade as function:
    class func_code: pass
    func_code=func_code()
    func_code.co_varnames='self','REQUEST','RESPONSE'
    func_code.co_argcount=3

    manage_options = (
        OFS.PropertyManager.PropertyManager.manage_options +
        XMLKitBase.XMLClientBase.manage_options +
        XMLKitBase.XMLServerBase.manage_options +
        XMLKitBase.XMLReloadBase.manage_options +
        OFS.History.Historical.manage_options +
        OFS.SimpleItem.SimpleItem.manage_options
    )
    _properties=(
        XMLKitBase.XMLClientBase._properties +
        XMLKitBase.XMLServerBase._properties +
        XMLKitBase.XMLReloadBase._properties
    )

    def __init__(self, id, source):
        """ """
        self.id = id
        self.source = source
        self.xp = XML.XMLParser.XMLParser()

    def _internal_initEmpty(self):
        """ Clear the DOM """
        self.xp.reset()

    def _internal_reload(self):
        """ Reload the XML data """
        try:
            source = self.unrestrictedTraverse(self.source).absolute_url()
        except:
            source = self.source
        self.xp.runURL(source)

    def _internal_getDOMref(self):
        """ Return a reference to the DOM """
        return self.xp.DOM

    def _internal_setDOMref(self, newDOM):
        """ replace the DOM with a new one """
        self.xp.DOM = newDOM

Globals.default__class_init__(XMLProxy)
